'---------------------------------
' variable
'---------------------------------
Dim allUsersPrograms
Dim programs
Dim objSysInfo, objUser
Dim linkPath
Dim linkShortPath
Dim basePath
Dim instPath
Dim servicePath
Dim language
Dim language_code
Dim startm
Dim stopm
Dim installm
Dim uninstallm
Dim start_service
Dim stop_service
Dim install_service
Dim remove_service
Dim osversion

'--------------------------------
' language en(0),de(1),it(2),fr(3)
'--------------------------------
startm=Array("Start application","Applikation starten","Avvia applicazione","Dmarrer application")
stopm=Array("Stop application","Applikation stoppen","Arresta applicazione","Arrter application")
installm=Array("Install application","Applikation installieren","Installare applicazione","Installer application")
uninstallm=Array("Uninstall application","Applikation deinstallieren","Disinstallare applicazione","Dsinstaller application")

start_service=Array("Start service","Starte Service","Avvia servizio","Dmarrer service")
stop_service=Array("Stop service","Stoppe Service","Arresta servizio","Arrter service")
install_service=Array("Install service","Installiere Service","Installare servizio","Installer service")
remove_service=Array("Remove service","Entferne Service","Rimuovere servizio","liminer service")

'--------------------------------
' cmd arguments
'--------------------------------

basePath = Wscript.Arguments(0)
instPath = Wscript.Arguments(1)
language = Wscript.Arguments(2)

Select Case language

  case "en"
    language_code = 0
  case "de"
    language_code = 1
  case "it"
    language_code = 2
  case "fr"
    language_code = 3
  case else
    language_code = 0
       
End Select

'-------------------------------
Set wshShell = WScript.CreateObject("WScript.Shell")

Set SystemSet = GetObject("winmgmts:").InstancesOf ("Win32_OperatingSystem") 
for each System in SystemSet 
  osversion = CDbl(Left(System.Version,3))
next

If osversion > 6.1 Then
  basePath = Replace(basePath,"\",".") 
End If

allUsersPrograms = wshShell.SpecialFolders("AllUsersPrograms")
programs = wshShell.SpecialFolders("Programs")

linkPath = programs & "\" & basePath
servicePath = linkPath & "\Service"
call CreateDirectoryPath(servicePath)

'Adapter
shortcutFile = linkPath & "\" & startm(language_code) & ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\start-application.cmd"
shortcut.Save()

shortcutFile = linkPath & "\" & stopm(language_code) & ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\stop-application.cmd"
shortcut.Save()

shortcutFile = linkPath & "\" & uninstallm(language_code) & ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\uninstall.cmd"
shortcut.Save()

'Service
shortcutFile = servicePath & "\" & install_service(language_code) & ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\service\install.cmd"
shortcut.Save()

shortcutFile = servicePath & "\" & remove_service(language_code )& ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\service\remove.cmd"
shortcut.Save()

shortcutFile = servicePath & "\" & start_service(language_code) & ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\service\start.cmd"
shortcut.Save()

shortcutFile = servicePath & "\" & stop_service(language_code) & ".lnk"
Set shortcut = wshShell.CreateShortcut(shortcutFile)      
shortcut.TargetPath = instPath & "\bin\service\stop.cmd"
shortcut.Save()

' Append delete Start menu entries in uninstall
uPath = instPath & "\bin\helper\uninstall.cmd"
Set fso = CreateObject("Scripting.FileSystemObject")
linkShortPath = fso.GetFolder(programs).ShortPath
Set inFile  = fso.OpenTextFile(uPath, 1)
Set outFile = fso.OpenTextFile(uPath & ".tmp", 2, True)
Do Until inFile.AtEndOfStream
  line = inFile.ReadLine
  If InStr(line, "@START_MENU@") Then
    outFile.WriteLine("cd " & Chr(34) & linkShortPath & Chr(34))
    outFile.WriteLine("rmdir /S /Q " & Chr(34) & basePath & Chr(34))
  Else
    outFile.WriteLine line
  End If
Loop
inFile.Close
outFile.Close

fso.DeleteFile(uPath)
fso.MoveFile uPath & ".tmp", uPath

' ###################################################################################
Function CreateDirectoryPath(DirPath)
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  If objFSO.FolderExists(DirPath) Then
    Exit Function
  End If

  aDirectories = Split(DirPath, "\")
  sCreateDirectory = aDirectories(0)
  For iDirectory = 1 To UBound(aDirectories)
    sCreateDirectory = sCreateDirectory & "\" & aDirectories(iDirectory)
    If Not objFSO.FolderExists(sCreateDirectory) Then
      objFSO.CreateFolder(sCreateDirectory)
    End If
  Next
End Function